 /* libnltrack
    Copyright (C) 2008 Ercan Akyürek <geforcefan@googlemail.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more dedas warn spaß, ich würde dich nicht mal auf unser geländer lassentails.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/

#include "libnltrack.h"


int main() 
{
	int i=0, j=0;
	FILE *file;

	NlTrack test;
	NlOpen("test.nltrack", &test);

	file = fopen("test.txt", "wb");

	printf("\n=======================\n"
				 "Track: \"test.nltrack\"\n"
				 "=======================\n\n");

	printf("NoLimits Coaster Track Version: %d.%d.%d \n\n", test.major, test.minor, test.revision);

	printf("Track Style: %s (Num: %d)\n", NlGetCoasterType( test.style ), test.style );
	printf("Use 1.6 friction: %s\n", (test.use16friction == 1) ? "true" : "false");
	printf("Operating mode: %s\n", (test.trackMode == 1) ? "Suttle mode" : "Normal mode");
	printf("Num Trains: %d\n", test.numTrains);
	printf("Num Cars: %d\n\n", test.numCars);

	printf("Track Spine Color: R=%x G=%x B=%x A=%x\n", test.trackSpineColor.r,
																							test.trackSpineColor.g,
																							test.trackSpineColor.b,
																							test.trackSpineColor.a);
	printf("Track Rail Color: R=%x G=%x B=%x A=%x\n", test.trackRailColor.r,
																							test.trackRailColor.g,
																							test.trackRailColor.b,
																							test.trackRailColor.a);
	printf("Track Crosstie Color: R=%x G=%x B=%x A=%x\n", test.trackCrosstieColor.r,
																							test.trackCrosstieColor.g,
																							test.trackCrosstieColor.b,
																							test.trackCrosstieColor.a);
	printf("Supports Color: R=%x G=%x B=%x A=%x\n", test.supportsColor.r,
																							test.supportsColor.g,
																							test.supportsColor.b,
																							test.supportsColor.a);
	printf("Train Seat Color: R=%x G=%x B=%x A=%x\n", test.trainSeatColor.r,
																							test.trainSeatColor.g,
																							test.trainSeatColor.b,
																							test.trainSeatColor.a);
	printf("Train Restraint Color: R=%x G=%x B=%x A=%x\n", test.trainRestraintColor.r,
																							test.trainRestraintColor.g,
																							test.trainRestraintColor.b,
																							test.trainRestraintColor.a);
	printf("Train Color: R=%x G=%x B=%x A=%x\n", test.trainColor.r,
																							test.trainColor.g,
																							test.trainColor.b,
																							test.trainColor.a);
	printf("Train Gear Color: R=%x G=%x B=%x A=%x\n\n", test.trainGearColor.r,
																							test.trainGearColor.g,
																							test.trainGearColor.b,
																							test.trainGearColor.a);
	printf("Use Tunnel Color: %s\n", (test.useTunnelColor == 1) ? "true" : "false");
	printf("Tunnel Color: R=%x G=%x B=%x A=%x\n", test.tunnelColor.r,
																							test.tunnelColor.g,
																							test.tunnelColor.b,
																							test.tunnelColor.a);

	for(;i<=test.numTrains-1; i++) {

		printf("\n=========\n"
					 "Train %d\n"
					 "=========\n\n", i+1);		

		printf("Use Individual Color: %s\n", (test.train[i].useIndividualColor == 1) ? "true" : "false" );
		printf("Texture Filename: %s\n\n", test.train[i].textureFilename);
		printf("Seat Color: R=%d G=%x B=%x A=%x\n", test.train[i].seatColor.r,
																								test.train[i].seatColor.g,
																								test.train[i].seatColor.b,
																								test.train[i].seatColor.a);
		printf("Restraint Color: R=%x G=%x B=%x A=%x\n", test.train[i].restraintColor.r,
																								test.train[i].restraintColor.g,
																								test.train[i].restraintColor.b,
																								test.train[i].restraintColor.a);
		printf("Train Color: R=%x G=%x B=%x A=%x\n", test.train[i].trainColor.r,
																								test.train[i].trainColor.g,
																								test.train[i].trainColor.b,
																								test.train[i].trainColor.a);
		printf("Gear Color: R=%x G=%x B=%x A=%x\n", test.train[i].gearColor.r,
																								test.train[i].gearColor.g,
																								test.train[i].gearColor.b,
																								test.train[i].gearColor.a);

	}


	printf("\n=========\n"
				"INFO\n"
				"=========\n\n");		
	printf("Author Comments: \n------------------------------------\n%s", test.authorComments);
	printf("------------------------------------\n");


	printf("\n=========\n"
				"Beziers\n"
				"=========\n\n"
				"Number of Beziers: %d\n", test.numBeziers);		

	for(i=0;i<=test.numBeziers-1; i++) {

		printf("\n=========\n"
					 "Bezier %d\n"
					 "=========\n\n", i+1);		

		printf("Banking: %2.0f degrees\n", test.beziers[i].roll * 57.29577951);
	}

	printf("\n=========\n"
				"Free Nodes\n"
				"=========\n\n"
				"Number of Free Nodes: %d\n", test.totalFreeNodes);		

	for(i=0;i<=test.totalFreeNodes-1; i++) {
		printf("\n=========\n"
					 "Free Node %d (Index %d)\n"
					 "=========\n\n", i+1, i);		
		printf("X: %f\nY: %f\nZ: %f\n", test.freeNodes[i].posX, 
																		test.freeNodes[i].posY, 
																		test.freeNodes[i].posZ);
	}

	printf("\n=========\n"
				"Fund Nodes\n"
				"=========\n\n"
				"Number of Fund Nodes: %d\n", test.totalFundNodes);		
 
	for(i=0;i<=test.totalFundNodes-1; i++) {
		printf("\n=========\n"
					 "Fund Node %d (Index %d)\n"
					 "=========\n\n", i+1, i);		
		printf("X: %f\nY: %f\nZ: %f\n", test.fundNodes[i].posX, 
																		test.fundNodes[i].posY, 
																		test.fundNodes[i].posZ);
	}
 
	printf("\n=========\n"
				"Segm Nodes\n"
				"=========\n\n"
				"Number of Segm Nodes: %d\n", test.totalSegment);		
 
	for(i=0;i < test.totalSegment; i++) {
		printf("\n=========\n"
					 "Segment Node %d\n"
					 "=========\n\n", i+1);	
						for (j = 0; j < test.seg[i].totalRASCs; j++)
						{

						printf("\n=========\n"
								 "Segm Node %d\n"
								 "=========\n\n", j+1);	

							printf("Type: %d\n", test.seg[i].data[j].type);			
							printf("Pos: %f\n", test.seg[i].data[j].pos);		
						}	
	}
	
	printf("\n=========\n"
				"Segments \n"
				"=========\n\n"
				"Number of Segments: %d\n", test.totalSegments);			

				for (i = 0; i < test.totalSegments; i++)
				{
						printf("\n=========\n"
									 "Segment %d\n"
									 "=========\n\n", i+1);		
						printf("Type: %d\n", test.segs[i].type);				
				}

    system("pause");

	return 0;
}
